=== debian/changelog ===
cp2k (2.5.1-3) unstable; urgency=medium

  * debian/cp2k.links: Fix symlink (Closes: #749558).
  * debian/upstream: Moved to debian/upstream/metadata.
  * debian/cp2k-data.install: Added HFX_BASIS, BASIS_ZIJLSTRA and
    nm12_parameters.xml data files.
  * debian/control (Build-Depends): Added libelpa-dev.
  * debian/patches/makeflags.patch: Enable ELPA support.
  * debian/rules (override_dh_auto_test): Added QS/regtest-gpw-6-4 regtest for
    ELPA.

 -- Michael Banck <mbanck@debian.org>  Sat, 11 Oct 2014 16:13:57 +0200

cp2k (2.5.1-2) unstable; urgency=medium

  * debian/patches/libxc-2.1_support.patch: New patch, adds support for (new
    functionals in) libxc-2.1, adopted from upstream revision 14113.
  * debian/patches/gth_potentials_update.patch: New patch, includes additions
    from the master GTH_POTENTIALS file up till revision 13090.

 -- Michael Banck <mbanck@debian.org>  Mon, 07 Jul 2014 00:26:45 +0200

cp2k (2.5.1-1) unstable; urgency=low

  * New upstream point release.
    + Adds double-escaping of some XML entities, fixing an FTBFS bug on
      archictures using gcj-jdk.
  * debian/rules (override_dh_auto_test): Added QS/regtest-md-lgvregion regtest
    directory to get some coverage of the CPMD-like Langevin MD.
  * debian/patches/potentials_allectron.patch: New patch, adds the allelectron
    potentials from tests/QS/POTENTIAL.
  * debian/patches/makeflags.patch: Added psmp (hybrid OpenMP/MPI) flavor.
  * debian/rules (VERSION): New variable.
  * debian/rules (override_dh_auto_clean, override_dh_auto_build,
    override_dh_auto_test): Use it.
  * debian/cp2k.links: Use wildcard instead of parallel flavor identifier.

 -- Michael Banck <mbanck@debian.org>  Sat, 19 Apr 2014 14:15:22 +0200

cp2k (2.5.0-1) unstable; urgency=low

  * New upstream release, new features include:
    + MP2 and RI-MP2 gradients
    + Absolutely Localized Molecular Orbitals SCF (ALMO-SCF) energies
      for linear scaling of molecular systems
    + Global optimization of geometries
    + Tree Monte Carlo: additional parallelism in MC
    + Post-SCF linear response, including Raman
    + Relativistic corrections for atomic blocks
    + Integrated molecular basis set optimization
    + RI-MP2 auxiliary basis optimization

  [ Michael Banck ]
  * debian/control (Description): Overhauled.
  * debian/cp2k-data.install: Added NLCC_POTENTIALS data file.
  * debian/upstream: Updated citation reference and Repository-Browse URL.
  * debian/patches/testsuite_output.patch: Refreshed.
  * debian/cp2k.examples: Updated for moved regtest.
  * debian/cp2k.docs: Removed, the tutorials were moved to the website.
  * debian/rules (override_dh_auto_clean, override_dh_auto_build): Directory
    "web/manual" got renamed to "tools/manual", rename acoordingly.  Also drop
    the javascript-enabled version of the manual, as the respective .xsl file
    no longer exists (or rather, the javascript version is now the standard).
  * debian/cp2k-data.install: Likewise.
  * debian/rules (override_dh_auto_test): do_regtest has been moved to
    tools/regtesting, rename accordingly.
  * debian/regtest.config: Likewise.
  * debian/regtest.config: New variables "quick", "nobuild" and "nosvn".
  * debian/rules (override_dh_auto_test): Remove -quick option from
    command-line. 
  * debian/patches/makefile_linking.patch: New patch, adds required internal
    and external libraries to fes linking command-line.
  * debian/patches/makeflags.patch: Removed OBJECTS_ARCHITECTURE variable, as
    it is on longer used by the code.
  * debian/control (Description): Updated for new 2.5.0 features.
  * debian/rules (override_dh_auto_test): Replaced several regtest directories
    with similar, but quicker to run, directories.  Also add several more
    regtest directories.
  * debian/patches/fortran_continuing_lines.patch: Removed, no longer needed.
  * debian/patches/subversion_branch.patch: New patch, adds revisions from
    upstream cp2k-2_5-branch: r13644. 

 -- Michael Banck <mbanck@debian.org>  Sat, 01 Mar 2014 17:17:41 +0100
