=== debian/changelog ===
cp2k (2.6.1-2~bpo80+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Michael Banck <mbanck@debian.org>  Thu, 17 Sep 2015 23:51:17 +0200

cp2k (2.6.1-2) unstable; urgency=medium

  * debian/regtest.config: Hardcode platform to `Linux' as is done for
    building, so the regression tests can find the executable.
  * debian/rules (override_dh_auto_test): Added QS/regtest-sccs for SCCS.
  * debian/control (Description): Updated.
  * debian/cp2k-data.links: Removed, no longer needed, and actually harmful as
    it overwrites the combined POTENTIAL file with the GTH_POTENTIALS file.
  * debian/patches/data_files_standard_location.patch: Update default
    location for HFX and MP2 pair potential files, update check for data file
    existance during HFX setup to use file_exist() subroutine and update all
    occurrances of direct calls to OPEN() for data files with open_file()
    subroutines, taken from upstream revisions 14965, 15250 and 15287.
  * debian/upstream/metadata: Update version number and year in software
    package citation.
  * debian/upstream/metadata: Add Comp. Mol. Sci. article.

 -- Michael Banck <mbanck@debian.org>  Sun, 03 May 2015 16:24:18 +0200

cp2k (2.6.1-1) unstable; urgency=medium

  * New upstream release, new features include:
    + Improved linear scaling routines
    + Self-consistent continuum solvation (SCCS) model
    + QM/MM for Density-Functional Tight Binding (DFTB)
    + Realtime-Propagation (RTP) and Ehrenfest Molecular Dynamics (EMD) with
      Hartree-Fock exchange
    + QUIP Manybody potential
    + Hirshfeld population analysis
    + Density-Matrix (DM) and Charge Constraint Projection based ADMM methods
    + K-points framework
    + Improved Random-Phase Approximation (RPA) frequency integration methods
    + Local Resolution of Identity Projector Augmented Wave method (LRIGPW)
    + Optimization of LRI basis sets
  * debian/patches/reset_cppflags_makdepf90.patch: Removed, no longer needed.
  * debian/patches/makefile_linking.patch: Likewise.
  * debian/patches/potentials_allectron.patch: Likewise.
  * debian/patches/libxc-2.1_support.patch: Likewise.
  * debian/patches/gth_potentials_update.patch: Likewise.
  * debian/patches/testsuite_output.patch: Refreshed.
  * debian/patches/makeflags.patch: Add __DATA_DIR define to $(DFLAGS).
  * debian/control (Build-Depends): Added python.
  * debian/cp2k-data.install: Install all data files from data/.
  * debian/cp2k.links: Fix symlink (Closes: #749558).
  * debian/upstream: Moved to debian/upstream/metadata.
  * debian/control (Build-Depends): Added libelpa-dev.
  * debian/patches/makeflags.patch: Enable ELPA support.
  * debian/rules (override_dh_auto_test): Added QS/regtest-gpw-6-4 regtest for
    ELPA.
  * debian/cp2k.install: Install cp2k_shell as well.
  * debian/cp2k.links: Add symlink for cp2k_shell.
  * debian/rules (override_dh_auto_test): Added QS/regtest-hirschfeld regtest for
    Hirshfeld charges and QMMM/DFTB/regtest for QM/MM DFTB.
  * debian/patches/data_files_standard_location.patch: Alternatively strip any
    path from provided files and look them up in the data directory directly.

 -- Michael Banck <mbanck@debian.org>  Fri, 01 May 2015 16:54:10 +0200
