=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
                debhelper (>= 7.0.50~),
                default-jre-headless,
                flex,
+               python, 
                gfortran,
                libblas-dev,
                libelpa-dev (>= 2013.11.008-2),
@@ -59,13 +60,15 @@
   * Dispersion corrections via DFT-D2 and DFT-D3 pair-potential models
   * Non-local van der Waals corrections for XC functionals including B88-vdW,
     PBE-vdW and B97X-D
+  * DFT+U (Hubbard) correction
   * Density-Fitting for DFT via Bloechl or Density Derived Atomic Point Charges
     (DDAPC) charges, for HFX via Auxiliary Density Matrix Methods (ADMM) and
-    for MP2/RPA via Resolution-of-the-identity (RI)
+    for MP2/RPA via Resolution-of-identity (RI)
   * Sparse matrix and prescreening techniques for linear-scaling Kohn-Sham (KS)
     matrix computation
   * Orbital Transformation (OT) or Direct Inversion of the iterative subspace
     (DIIS) self-consistent field (SCF) minimizer
+  * Local Resolution-of-Identity Projector Augmented Wave method (LRIGPW)
   * Absolutely Localized Molecular Orbitals SCF (ALMO-SCF) energies for linear
     scaling of molecular systems
   * Excited states via time-dependent density-functional perturbation theory
@@ -94,6 +97,7 @@
   * Several nudged-elastic band (NEB) algorithms (B-NEB, IT-NEB, CI-NEB, D-NEB)
     for minimum energy path (MEP) calculations
   * Global optimization of geometries
+  * Solvation via the Self-Consistent Continuum Solvation (SCCS) model
   * Semi-Empirical calculations including the AM1, RM1, PM3, MNDO, MNDO-d, PNNL
     and PM6 parametrizations, density-functional tight-binding (DFTB) and
     self-consistent-polarization tight-binding (SCP-TB), with or without
