=== debian/watch ===
# only follow the branches, so we know, when the next one is released

version=3
http://sf.net/cp2k/cp2k-([\d.]+)\.tar\.bz2
